package dk.nsp.idsas.test.stepdefinitions;

import dk.nsp.idsas.test.util.HttpClient;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;
import org.springframework.beans.factory.annotation.Value;

import java.io.IOException;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;

public class WsdlStepDefinitions {

    @Value("${idsas.service.endpoint}" + "/20230601")
    private String serviceEndpoint;

    @Value("${idsas.service-lookup.endpoint}" + "/20230601")
    private String lookupServiceEndpoint;

    private int responseCode;
    private String responseBody;

    @When("{string} wsdl hentes fra {string}")
    public void getWsdl(String wsdl, String service) throws IOException {
        String endpoint = service.equals("idsas") ? serviceEndpoint : lookupServiceEndpoint;
        String url = String.format("%s/%s?wsdl", endpoint, wsdl);

        HttpClient httpClient = new HttpClient();
        responseBody = httpClient.get(url);
        responseCode = httpClient.getResponseCode();
    }

    @Then("Returneres http kode {int}")
    public void validateResponseCode(int expectedResponseCode) {
        assertEquals(expectedResponseCode, responseCode);
    }

    @Then("Svaret er ikke tomt")
    public void validateNonEmptyReponseBody() {
        assertFalse(responseBody.isEmpty());
    }
}
