package dk.nsp.idsas.service;

import javax.sql.DataSource;
import java.util.List;
import java.util.stream.Collectors;

import dk.nsp.idsas.dao.entity.BlurringEntity;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.OrganisationIdClassificationType;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.OrganisationIdType;
import org.springframework.beans.factory.annotation.Autowired;

import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.BlurredOrganisationsResponseType;

import dk.nsp.idsas.dao.BlurringDao;

public class LookupService {
    @Autowired
    protected DataSource dataSource;

    public BlurredOrganisationsResponseType getActiveBlurrings(String patientId, String patientIdType) {
        BlurringDao blurringDao = new BlurringDao(dataSource);

        // Hente entiteter
        List<BlurringEntity> entityList = blurringDao.getActiveBlurrings(patientId, patientIdType);

        // Mappe entiteter til liste af id'ere
        List<OrganisationIdType> orgIdList = entityList.stream().map(entity -> {
            OrganisationIdType orgId = new OrganisationIdType();
            orgId.setId(entity.getOrganisationId());
            orgId.setClassification(OrganisationIdClassificationType.CVR);
            return orgId;
        }).collect(Collectors.toList());

        // Sætte id'ere ind i response
        BlurredOrganisationsResponseType result = new BlurredOrganisationsResponseType();
        result.getOrganisationIds().addAll(orgIdList);

        return result;
    }
}

